VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CColor"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

'The private members holding values of red, green, blue
'of the color.  Each of them can range from 0 to 63

Private R As Byte
Private G As Byte
Private B As Byte


Public Sub alter(desired As String, v As Integer)
'alters a color component
    Select Case UCase$(desired)
        Case "R"
            R = CByte(v)
        Case "G"
            G = CByte(v)
        Case "B"
            B = CByte(v)
    End Select
'done
End Sub



Public Sub fromRGB(inRGB As Long)
'assigns from vbColor format
'snap colors automatically
    Dim smallR As Byte
    Dim smallG As Byte
    Dim smallB As Byte
    'split inRGB into its components, ranging from 0-255
    'format of vbColor is &H00BBGGRR&
    smallR = CByte(inRGB Mod &H100&)
    smallG = CByte((inRGB \ &H100&) Mod &H100&)
    smallB = CByte((inRGB \ &H10000))
    'then convert its range to 0-63
    R = smallR \ 4
    G = smallG \ 4
    B = smallB \ 4
'done
End Sub


Public Sub assign(inR As Integer, inG As Integer, inB As Integer)
'assigns values to a color from input of inR, inG, inB
'each in the range of 0-63
    R = CByte(inR)
    G = CByte(inG)
    B = CByte(inB)
'done
End Sub


Public Function toDec(desired As String) As String
'get the value of R, G or B component of a color
'as decimal
    Select Case UCase$(desired)
        Case "R"
            toDec = CStr(R)
        Case "G"
            toDec = CStr(G)
        Case "B"
            toDec = CStr(B)
    End Select
'done
End Function

Public Function toHex(desired As String) As String
'get the value of R, G or B component of a color
'as hexadecimal
    Select Case UCase$(desired)
        Case "R"
            toHex = Hex(R)
        Case "G"
            toHex = Hex(G)
        Case "B"
            toHex = Hex(B)
    End Select
'done
End Function

Public Function toRGB() As Long
'converts CColor to vbColor format
    Dim bigR As Integer
    Dim bigG As Integer
    Dim bigB As Integer
    'convert the range from 0-63 to 0-255
    bigR = 4 * R
    bigG = 4 * G
    bigB = 4 * B
    'then call vb RGB function
    toRGB = CLng(RGB(bigR, bigG, bigB))
'done
End Function

Public Function toValue(desired As String) As Integer
'get the value of R, G or B component of a color
    Select Case UCase$(desired)
        Case "R"
            toValue = CInt(R)
        Case "G"
            toValue = CInt(G)
        Case "B"
            toValue = CInt(B)
    End Select
'done
End Function

Private Sub Class_Initialize()
'initialize as black
    R = 0
    G = 0
    B = 0
End Sub


